#pragma once

#include "types.h"

namespace Driver
{
  class Base
    {
    public:
      template< typename T >
	T read(Address address) const;

      template< typename T >
	void write(Address address, T value) const;
    };

  template< typename T >
    T Base::read(Address address) const
      { return *(volatile T *)address; }

  template< typename T>
    void Base::write(Address address, T value) const
      { *(volatile T *)address = value; }

}
