#pragma once

#include "types.h"

namespace Driver
{
  class Bus
    {
    public:
      virtual Unsigned8 read8(Address address) = 0;
      virtual Unsigned16 read16(Address address) = 0;
      virtual Unsigned32 read32(Address address) = 0;

      virtual void write8(Address address, Unsigned8 value) = 0;
      virtual void write16(Address address, Unsigned16 value) = 0;
      virtual void write32(Address address, Unsigned32 value) = 0;
    };

  class Mem_bus : public Bus
    {
    public:
      virtual Unsigned8 read8(Address address);
      virtual Unsigned16 read16(Address address);
      virtual Unsigned32 read32(Address address);

      virtual void write8(Address address, Unsigned8 value);
      virtual void write16(Address address, Unsigned16 value);
      virtual void write32(Address address, Unsigned32 value);
    };

  class Io_bus : public Bus
    {
    public:
      virtual Unsigned8 read8(Address address);
      virtual Unsigned16 read16(Address address);
      virtual Unsigned32 read32(Address address);

      virtual void write8(Address address, Unsigned8 value);
      virtual void write16(Address address, Unsigned16 value);
      virtual void write32(Address address, Unsigned32 value);
    };
}
