#pragma once

namespace Driver
{
  class Icu
  {
  public:
    /**
     * Enable an interrupt source
     * \param irq	irq number
     */
    virtual void enable(unsigned irq) = 0;
    /**
     * Disable an interrupt source
     * \param irq	irq number
     */
    virtual void disable(unsigned irq) = 0;
    /**
     * Acknowledge an interrupt source
     * \param irq	irq number
     */
    virtual void ack(unsigned irq) = 0;
    /**
     * Get pending interrupt number
     * \return		current highest pending interrupt
     */
    virtual unsigned pending() = 0;
  };
}
