#pragma once

#include "types.h"

namespace Driver
{
  typedef Unsigned16 Port;

  class Io
    {
    public:
      template< typename T >
	T read(Port port) const;

      template< typename T >
	void write(Port port, T val) const;
    };
  
  template< typename T >
    T Io::read(Port port) const
      {
	T val = 0;
	
	switch (sizeof(T))
	  {
	  case 1:
	    asm volatile ("inb %w1, %b0": "=a" (val) : "Nd" (port));
	    break;

	  case 2:
	    asm volatile ("inw %w1, %w0": "=a" (val) : "Nd"(port));
	    break;

	  case 4:
	    asm volatile ("in %w1, %0": "=a"(val) : "Nd"(port));
	    break;

	  default:
	    break;
	  }

	return val;
      }

  template< typename T>
    void Io::write(Port port, T val) const
      {
	switch (sizeof(T))
	  {
	  case 1:
	    asm volatile ("outb %b0, %w1": : "a"(val), "Nd"(port));
	    return;

	  case 2:
	    asm volatile ("outw %w0, %w1": : "a"(val), "Nd"(port));
	    return;

	  case 4:
	    asm volatile ("out %0, %w1": : "a"(val), "Nd"(port));
	    return;

	  default:
	    return;
	  }
      }
}
