#pragma once

#include "bus.h"
#include "timer.h"

namespace Driver
{
  class Timer_i8254 : public Timer
    {
      enum
	{
	  Ch0 = 0x00,
	  Ch1 = 0x01,
	  Ch2 = 0x02,
	  Cmd = 0x03,
	};

      enum
	{
	  Clock_tick_rate = 1193180,
	};
    
    public:
      Timer_i8254(Bus *bus, Address _base);
      void init(unsigned interval);
      void ack();

    protected:
      void wr(Address reg, Unsigned8 val);

    private:
      Bus *_bus;
      Address _base;
    };
}
