#pragma once

#include "bus.h"
#include "timer.h"

namespace Driver
{
  class Sp804 : public Timer
    {
      // system control
      enum
	{
	  Timer1_enable = 15,
	  Timer2_enable = 17,
	  Timer3_enable = 19,
	  Timer4_enable = 21,
	};

      enum
	{
	  Reg_load   = 0x00,
	  Reg_value  = 0x04,
	  Reg_ctrl   = 0x08,
	  Reg_intclr = 0x0c,

	  Ctrl_ie        = 1 << 5,
	  Ctrl_periodic  = 1 << 6,
	  Ctrl_enable    = 1 << 7,
	};

    public:
      Sp804(Bus *bus, Address base);
      void init(unsigned interval);
      void ack();

    protected:
      void wr(Address reg, Mword val);

    private:
      Bus *_bus;
      Address _base;
    };
}
