#pragma once

#include <stddef.h>
#include "base.h"

namespace Driver
{
  class Uart
  {
  public:
    virtual ~Uart() {}
    
    virtual bool startup() = 0;
    virtual void shutdown() = 0;

    /**
     * Write data to serial line
     * \param s		character array to send
     * \param count	number characters to send
     *
     * \return		number of characters send
     */
    virtual int write(char const *s, unsigned long count) = 0;
  };
};

