#pragma once

#include "uart.h"
#include "bus.h"

namespace Driver
{
  class Pl011 : public Uart
  {
  public:
    Pl011(Bus *bus, Address base)
       : _bus(bus), _base(base) {}
    
    bool startup();
    void shutdown();
    int write(char const *s, unsigned long count);
   
  protected:
    inline void out_char(char c) const;

    inline unsigned long rd(unsigned long reg) const;
    inline void wr(unsigned long reg, unsigned long val) const;
  
  private:
    Bus *_bus;
    Address _base;
  };
}
