#include "bus.h"

namespace Driver
{
  Unsigned8 Io_bus::read8(Address address)
    {
      Unsigned8 val = 0;
      asm volatile ("inb %w1, %b0": "=a" (val) : "Nd" (address));
      return val;
    }

  Unsigned16 Io_bus::read16(Address address)
    {
      Unsigned16 val = 0;
      asm volatile ("inw %w1, %w0": "=a" (val) : "Nd"(address));
      return val;
    }

  Unsigned32 Io_bus::read32(Address address)
    {
      Unsigned32 val = 0;
      asm volatile ("in %w1, %0": "=a"(val) : "Nd"(address));
      return val;
    }

  void Io_bus::write8(Address address, Unsigned8 val)
    {
      asm volatile ("outb %b0, %w1": : "a"(val), "Nd"(address));
    }

  void Io_bus::write16(Address address, Unsigned16 val)
    {
      asm volatile ("outw %w0, %w1": : "a"(val), "Nd"(address));
    }

  void Io_bus::write32(Address address, Unsigned32 val)
    {
      asm volatile ("out %0, %w1": : "a"(val), "Nd"(address));
    }
}
