#include "timer_i8254.h"

namespace Driver
{

Timer_i8254::Timer_i8254(Bus *bus, Address base)
  : _bus(bus), _base(base)
{}

void
Timer_i8254::init(unsigned freq)
{
  // set counter channel 0 to binary, mode2, lsb/msb
  wr(Cmd, 0x34);
  
  // set counter0 frequency
  const unsigned latch = Clock_tick_rate / freq;
  wr(Ch0, latch & 0xff);
  wr(Ch0, latch >> 8);
}

void
Timer_i8254::ack()
{}
  
void Timer_i8254::wr(Address reg, Unsigned8 val)
{
  _bus->write8(_base + reg, val);
}

}
