#include "timer_sp804.h"

namespace Driver
{
  Sp804::Sp804(Bus *bus, Address base)
    : _bus(bus), _base(base)
    {
      wr(Reg_ctrl, 0);
    }

  void Sp804::init(unsigned interval)
    {
      wr(Reg_load, interval);
      wr(Reg_value, interval);
      wr(Reg_ctrl, Ctrl_enable | Ctrl_periodic | Ctrl_ie);
    }

  void Sp804::ack()
    {
      wr(Reg_intclr, 0);
    }
  
  void Sp804::wr(Address reg, Mword val)
    {
      _bus->write32(_base + reg, val);
    }
}

