#include "types.h"
#include "uart_16550.h"

namespace Driver
{
  Uart_16550::Uart_16550(Bus* bus, Address base)
    : _bus(bus), _base(base)
    {}

  bool Uart_16550::startup()
    {
      wr(IER, 0x00);/* disable all rs-232 interrupts */
      wr(MCR, 0x0b);         /* out2, rts, and dtr enabled */
      wr(FCR, 0x01);            /* enable fifo */
      wr(FCR, 0x07);         /* clear rcv xmit fifo */
      wr(FCR, 0x01);            /* enable fifo */
      wr(LCR, 0x00);            /* clear line control register */

      /* clear all interrupts */
      rd(MSR);
      rd(IIR);
      rd(TRB);
      rd(LSR);

      // clear read buffer
      while(rd(LSR) & 1)
	rd(TRB);

      return 0;
    }

  int Uart_16550::write(char const *s, unsigned long count)
    {
      // XXX implement me!
      return count;
    }
  
  Unsigned8 Uart_16550::rd(Address reg)
    {
      // XXX implement me!
      return 0;
    }

  void Uart_16550::wr(Address reg, Unsigned8 val)
    {
      // XXX implement me!
    }
}
