#include <cstdio>
#include "exit.h"
#include "platform.h"
#include "thread.h"

void
ret_to_user()
{
  Thread *thread = Platform::cpu()->current_thread();
  
  extern int crt0_stack_high;
  extern char __ret_to_user;

  printf("exit:%d\n", thread->id());
  thread->dump_user_regs();
  
  asm volatile(
      "mov	sp, %1		\n" // reset stack pointer
      "mov	pc, %0		\n" // jump to exit code
      :
      : "r" (&__ret_to_user), "r" (&crt0_stack_high)
      : "memory"
      );
}
