OUTPUT_FORMAT("elf32-littlearm", "elf32-bigarm", "elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)

phys_addr = 0x1000;
virt_addr = 0x1000;
phys_off  = virt_addr - phys_addr;

SECTIONS
{
  . = phys_addr;

  .text.init :
  {
    *(.text.init)
  }
 
  . = ALIGN(4k);
  . = . + phys_off;
  
  _stext = .;
  
  .text.kernel : AT (ADDR(.text.kernel) - phys_off)
  {
    *(.text .text.* .gnu.linkonce.t.*)
    KEEP (*(.fini))
    
    . = ALIGN(0x40);
    
    *(.rodata .rodata.* .gnu.linkonce.r.*)
  }
  
  _etext = .;
  PROVIDE (etext = .);
  . = ALIGN(4K);
  
  .data : AT (ADDR(.data) - phys_off)
  {
    *(.data .data.* .gnu.linkonce.d.*)
    _edata = .;
    PROVIDE (edata = .);
    
    . = ALIGN(4K);
    
    _module_info_start = .;
    *(.module_info)
    _module_info_end   = .;
    
    . = ALIGN(4K);
  
    PROVIDE (ivt_start = .);
    *(.vect)
    PROVIDE (ivt_end = .);
  
  _bss_start = .;
   *(.dynbss)
   *(.bss .gnu.linkonce.b.*)
   *(COMMON)
  _bss_end = .;
  }
  
  _end = . ;
  PROVIDE (end = .);
  . = ALIGN(4K);
 
  .data.m :
  {
    _modules_start = .;
    *(.module.data)
    . = ALIGN(4K);
    _modules_end   = .;

    . = ALIGN(4K);
    _module_data_start = .;
    *(.module_data)
    _module_data_end = .;
  }
  
  /DISCARD/ : 
  {
    *(.hash)
    *(.dynsym)
    *(.dynstr)
    *(.rel.dyn)
    *(.interp)
    *(.comment)
    *(.note)
    *(.stab)
    *(.fini)
  }
}
