#include <cstdio>
#include "user_state.h"

User_state::User_state(Mword pc)
{
  for (unsigned i = 0; i < 16; ++i)
    r[i] = 0;
  r[Reg_pc] = pc;
  
  // Mode_usr with irq enabled
  cpsr = 0x10;
}

void
User_state::dump()
{
  printf("r0:%08lx r1:%08lx r2:%08lx r3:%08lx\n",
      r[0], r[1], r[2], r[3]);
  printf("sp:%08lx lr:%08lx pc:%08lx cpsr:%08lx\n",
      r[Reg_sp], r[Reg_lr], r[Reg_pc], cpsr);
}

//----------------------------------------------------------------------------

unsigned
Sys_state::nr()
{
  return r[0];
}

unsigned
Sys_state::dest()
{
  return r[1];
}

void
Sys_state::ret(int ret)
{
  r[0] = ret;
}

void
Sys_state::copy_to(Sys_state *dest)
{
  dest->r[2] = r[2];
  dest->r[3] = r[3];
  dest->r[4] = r[4];
}

