.globl _start
_start:
	// load global desriptor table
	lgdt	gdt_desc
	ljmp	$0x08, $entry_prot
	
entry_prot:
	// initialize segment register
	mov	$0x10, %ax
	mov	%ax, %ds
	mov	%ax, %es
	mov	%ax, %fs
	mov	%ax, %gs
	mov	%ax, %ss

	// initialize stack pointer
	leal	crt0_stack_high, %esp
	// jump to next function
	jmp	__main

.section ".data"

// GDT data

.globl gdt_desc
gdt_desc:
	.word gdt_end-gdt_base-1
	.long gdt_base

.globl gdt_base
gdt_base:
	.long	0x00000000, 0x00000000
	.long	0x0000ffff, 0x00cf9b00 // kernel code
	.long	0x0000ffff, 0x00cf9300 // kernel data
	.long	0x0000ffff, 0x00cffb00 // user code
	.long	0x0000ffff, 0x00cff300 // user data
.globl tss_entry
tss_entry:
	.long	0x00000068, 0x00008900 // TSS need to be filled
gdt_end:

// index for the TSS in the GDT

.globl tss_sel
tss_sel:
	.word	0x28

// TSS data

.globl tss_base
tss_base:
	.long	0x00000000
.globl tss_esp0
tss_esp0:
	.long	0x00000000
	.word	0x0010
	.word	0x0000
	.space	96	

// 2KB stack size

.section ".data"
.align	4096
	.global crt0_stack_low
crt0_stack_low:
	.space	8192
	.global crt0_stack_high
crt0_stack_high:

.section ".init"
_mb_header:
	.long	0x1BADB002
	.long	0x00000002
	.long	0 - 0x1BADB002 - 2

