#pragma once

#include "types.h"

class Mem_layout
{
public:
  enum
    {
      Phys_ram_base	= 0x00000000,
      User_ram_base     = 0x01000000,
      Phys_ram_end	= 0x08000000,
      Phys_device_base	= 0x10000000,
      Phys_system_base	= Phys_device_base,
      Phys_ctrl_base	= Phys_device_base + 0x00001000,
      Phys_uart0_base	= Phys_device_base + 0x00009000,
      Phys_timer0_base	= Phys_device_base + 0x00011000,
      Phys_timer2_base	= Phys_device_base + 0x00012000,
      Phys_gic_cpu_base	= Phys_device_base + 0x00040000,
      Phys_gic_dist_base = Phys_device_base + 0x00041000,
      Phys_device_end	= 0x10100000,
    };

  enum
    {
      Virt_device_base	= 0xe0000000,
      Virt_device_end	= 0xe0100000,
      Virt_ram_base	= 0xf0000000,
      Virt_ram_end	= 0xf0000000 + (4 << 20),
    };

  static Address virt_to_phys(Address va)
    { return va; }

  static Address phys_to_virt(Address pa)
    { return pa; }
};

enum 
{
  Virt_ofs = Mem_layout::Phys_ram_base - Mem_layout::Virt_ram_base,
};
