#include <cstdio>
#include <cstring>
#include "cpu.h"
#include "startup.h"
#include "thread.h"
#include "platform.h"
#include "user.h"

void *operator new(size_t size) throw()
{
  printf("Warning: operator new called\n");
  while (1) {};
}

void operator delete(void *)
{}

//----------------------------------------------------------------------------

void set_stdio_uart(Driver::Uart *uart);

void startup()
{
  Platform::init();
  set_stdio_uart(Platform::uart());
  Space::init_root();

  printf("Femto Kernel starting ...\n");
  // create idle thread
  static Thread kernel_thread(Thread::State_idle, Space::root());
  // create applications
  Loader::exec();
  
  // execute idle thread
  Platform::cpu()->current_thread(&kernel_thread);
  
  printf("Femto Kernel finished\n");
  while (1) {};
}
