#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <alloca.h>

#include "elf_read.h"

int
read_elf(Binary *binary)
{
  ElfW(Ehdr) *x = (ElfW(Ehdr) *)binary->start();
  ElfW(Phdr) *phdr, *ph;

  if (!l4util_elf_check_magic(x))
    return -1;

  if (!l4util_elf_check_arch(x))
    return -2;

  binary->entry(x->e_entry);

  phdr   = l4util_elf_phdr(x);

  for (int i = 0; i < x->e_phnum; i++)
    {
      ph = (ElfW(Phdr)*)((Address)phdr + i * x->e_phentsize);
      if (ph->p_type == PT_LOAD)
	{
	  int type = EXEC_SECTYPE_ALLOC | EXEC_SECTYPE_LOAD;
	  
	  if (ph->p_flags & PF_R) type |= EXEC_SECTYPE_READ;
	  if (ph->p_flags & PF_W) type |= EXEC_SECTYPE_WRITE;
	  if (ph->p_flags & PF_X) type |= EXEC_SECTYPE_EXECUTE;
	  
	  binary->load(ph->p_offset, ph->p_filesz, ph->p_paddr, ph->p_vaddr, ph->p_memsz, type);
	}
    }

  return 0;
}
