#pragma once

#include "elf.h"

#define EXEC_SECTYPE_READ		(0x000001)
#define EXEC_SECTYPE_WRITE		(0x000002)
#define EXEC_SECTYPE_EXECUTE		(0x000004)
#define EXEC_SECTYPE_ALLOC		(0x000100)
#define EXEC_SECTYPE_LOAD		(0x000200)

class Binary
{
public:
  virtual void *start() = 0;
  virtual void entry(unsigned entry) = 0;
  virtual void load(unsigned p_offset, unsigned p_filesz, unsigned p_paddr,
                    unsigned p_vaddr, unsigned p_memsz, int type) = 0;
};

int read_elf(Binary *binary);
